Skip to main content

Your submission was sent successfully! Close

Thank you for signing up for our newsletter!
In these regular emails you will find the latest updates from Canonical and upcoming events where you can meet our team.Close

Thank you for contacting us. A member of our team will be in touch shortly. Close

  1. Blog
  2. Article

Adam Stokes
on 27 July 2017

Conjure-up dev summary highlights: screen ordering and improved deploy


Screen Ordering

Previously, you would go through the install journey by picking your spell, selecting a cloud, modifying charm options, and then waiting for bootstrap/applications to be completely deployed prior to performing the post processing steps. In this latest update we’ve moved all steps to be completed prior to any of those longer blocking tasks.

This allows you to see the complete picture and giving you the ability to go back and make updates to your configuration items prior to running the longer tasks of the deployment.

Deployment resilience

We use a mechanism for determining when a deployment has “finished”, meaning, all hooks have been fired and each application is in a ready state to handle the next set of instructions from the installer. In some cases an application may get into a state of error but quickly resolve itself.

This was causing us some issues as we were taking a very strict approach that if there is an error in the application then the deployment should fail. Even though this is the proper thing to do we’ve made a decision that if the application is able to fix itself then we shouldn’t pass on that failed experience to the user since technically the deployment is able to finish and function as intended.

To combat this we’ve made our deployment checker a little more lenient and performing retries (up to 5 times) to validate if an application does fix itself. However, since an error was seen in the application it should not go unnoticed and needs to be fixed in the charm itself. In our integration tests we have an environment variable CONJURE_UP_MODE that can be set to test and gives us the ability to fail on charm failures and get those bugs reported upstream and resolved.

Spell authors can make use of this feature in their own spells by updating the 00_deploy-done script with the following bits:

#!/bin/bash
set -eux
. "$CONJURE_UP_SPELLSDIR/sdk/common.sh"
retry_arg="-r5"
if [[ "${CONJURE_UP_MODE-}" == "test" ]]; then
 retry_arg=""
fi
if ! juju wait $retry_arg -vwm "$JUJU_CONTROLLER:$JUJU_MODEL"; then
 setResult "Applications did not start successfully"
 exit 1
fi
setResult "Applications Ready"
exit 0

Getting these changes

Installing the snap from the edge channel will give you the latest work outlined in these developer summaries:

sudo snap install conjure-up --classic --edge

 



      

Related posts


Canonical
9 May 2025

New 50 TOPS DC-ROMA RISC-V AI PC ships with Ubuntu Desktop 24.04 LTS pre-installed 

AI Article

Canonical is excited to announce the launch of DeepComputing’s new 50 TOPS DC-ROMA RISC-V AI PC and AI PC Mini with Ubuntu Desktop 24.04 LTS pre-installed. The PC was launched in collaboration with Framework and is powered by ESWIN’s advanced RISC-V AI SoC EIC7702X—featuring 8 SiFive’s high-performance P550 CPU cores .  Built on the DC-RO ...


Stephanie Domas
7 May 2025

CRA compliance: Things IoT manufacturers can no longer do under the CRA (and what to do instead)

Compliance Article

In this blog, I’ll give you a thorough overview of common IoT manufacturer and PDE developer practices that need immediate attention, and how to change or improve these practices so that you can pass CRA compliance. ...


Frank Heimes
6 May 2025

IBM LinuxONE 5 and Ubuntu Server, a great combination from day one

Cloud and server Article

Today, IBM announced the launch of their latest server: the new IBM LinuxONE Emperor 5. This fifth generation redefines IBM’s LinuxONE system as their most secure and high-performing Linux computing platform for data, applications and trusted AI.  Canonical supports LinuxONE Emperor 5 with Ubuntu Server. Ubuntu is cost-efficient and easy ...